# backbone-webdatabase

## 説明

Backbone.Model の fetch・save・destroy と Backbone.Collection の fetch が、
HTML5 の Web SQL Database にアクセスするようになるアダプタです。

## 使い方

### データベースの設定

    Backbone.DATABASE_NAME = "backbone";

### テーブルの定義

モデルに table という属性でテーブルを定義します。
第1引数にはテーブル名、第2引数には列の定義を渡します。

    var User = Backbone.Model.extend({
        table: new Table("users", {
            name: "TEXT",
            age: "INTEGER"
        });
    });

### テーブルの作成

    User.prototype.table.createTable({
        success: function(result) {
            alert("テーブルを作成しました。");
        },
        error: function(error) {
            alert("テーブルの作成に失敗しました。");
        }
    });

### テーブルの削除

    User.prototype.table.dropTable({
        success: function(result) {
            alert("テーブルを削除しました。");
        },
        error: function(error) {
            alert("テーブルの削除に失敗しました。");
        }
    });

### モデルの CRUD

    // 作成
    var user = new User({ name: "ichiro", age: 20 });
    user.save(null, {
        success: function(model) {
        },
        error: function(error) {
        }
    });

    // 取得
    user.id = 1;
    user.fetch({
        success: function(model) {
        },
        error: function(error) {
        }
    });

    // 更新
    user.set({ name: "shinji" });
    user.save(null, {
        success: function(model) {
        },
        error: function(error) {
        }
    });

    // 削除
    user.destroy({
        success: function(model) {
        },
        error: function(error) {
        }
    });

## 要望・不具合

要望や不具合の報告は GitHub プロジェクトの Issue で投稿して下さい。
不具合は修正します。要望については、作者が欲しいと思ったものは実装します。
Fork、Pull Request 歓迎。

## ライセンス

MIT ライセンス


